#ifndef __G_GUI_H__
#define __G_GUI_H__

#include <gear/base.h>
#include <sokol/sokol_gfx.h>
#include <sokol/sokol_app.h>
#include <sokol/util/sokol_imgui.h>

#define CIMGUI_DEFINE_ENUMS_AND_STRUCTS
#include <cimgui/cimgui.h>

typedef void (*g_gui_layer_destroy_function)(void* data);
typedef struct g_gui_layer {
    const char* name;
    bool open;
    void* data;
    void (*draw)(struct g_gui_layer* layer);
    g_gui_layer_destroy_function destroy;
} g_gui_layer;

typedef sl_vec(g_gui_layer*) g_gui_layers;
typedef g_gui_layer* (*g_gui_layer_create_function)();

typedef struct g_gui {
    g_gui_layers layers;
} g_gui;

// src/ui/gui/create.c
g_gui* g_gui_create();

// src/ui/gui/update.c
void g_gui_update(g_gui* gui);

// src/ui/gui/render.c
void g_gui_render();

// src/ui/gui/layers.c
void g_gui_add_layer(g_gui_layers* layers, g_gui_layer_create_function create_function, g_gui_layer_destroy_function destroy_function);

// src/ui/gui/destroy.c
void g_gui_destroy(g_gui* gui);

#endif
