workspace "GearProject"
    configurations { "Debug", "Release" }

project "gear-bin"
    kind "ConsoleApp"
	language "C++"
	cppdialect "C++11"

    targetdir "bin/%{cfg.buildcfg}"

    includedirs { ".", "include" }

    flags { "FatalWarnings" }
    warnings "High"

    files {
        "src/**.c",
        "src/**.cpp",
        "res/res.c",
        "**.glsl"
    }

    filter { "system:windows" }
        defines { "SOKOL_D3D11", "_CRT_SECURE_NO_WARNINGS" }

    filter { "system:linux" }
        defines { "SOKOL_GLCORE" }
        links { "X11", "Xi", "Xcursor", "GL", "dl", "pthread", "m", "asound" }

    filter { "system:macosx" }
        defines { "SOKOL_METAL" }
        links { "Cocoa.framework", "QuartzCore.framework", "Metal.framework", "MetalKit.framework", "AudioToolbox.framework" }
        files { "**.m" }

    filter "configurations:Debug"
        defines { "DEBUG" }
        symbols "On"

    filter "configurations:Release"
        defines { "NDEBUG" }
        optimize "Speed"

prebuildcommands {
    "xxd -i res/* > res/res.c"
}

buildcommands {
    "sokol-shdc --input *.glsl --output *.glsl.h --slang glsl430:hlsl5:metal_macos"
}

