#include <gear/images.h>
#include <gear/memory.h>

#include <string.h>
#include <log.c/log.h>

g_image* g_image_create(u8* pixels, i32 width, i32 height) {
    g_image* image = g_mem_calloc_named("Image", sizeof(g_image));
    image->width = width;
    image->height = height;
    image->channels = G_IMAGE_CHANNELS;
    image->pixels = pixels;

    return image;
}

g_image* g_image_default() {
    g_image* image = g_mem_calloc_named("Image", sizeof(g_image));
    image->width = G_IMAGE_MISSING_DIMENSIONS,
    image->height = G_IMAGE_MISSING_DIMENSIONS,
    image->channels = G_IMAGE_CHANNELS,
    image->pixels = g_mem_alloc(G_IMAGE_MISSING_BYTESIZE);
    memcpy(image->pixels, G_IMAGE_MISSING_PIXELS, G_IMAGE_MISSING_BYTESIZE);

    return image;
}
