#include <gear/memory.h>
#include <gear/ui/console.h>
#include <gear/ui/gui.h>
#include <log.c/log.h>

char fmt_input_buf[G_CONSOLE_MAX_LEN] = { 0 };
char fmt[G_CONSOLE_MAX_LEN];

void log_callback(log_Event* event) {
    strncpy(fmt, event->fmt, G_CONSOLE_MAX_LEN);
    strcat(fmt, "\n");
    sz len = vsnprintf(fmt_input_buf, G_CONSOLE_MAX_LEN, fmt, event->ap);

    g_console* console = event->udata;
    while(console->output.len + len >= G_CONSOLE_BUFFER_SIZE) {
        char* new_start = memchr(console->output.buf, '\n', G_CONSOLE_MAX_LEN);
        if(new_start == NULL) {
            new_start = console->output.buf;
        }

        new_start++;

        sz len = new_start - console->output.buf;
        memmove(console->output.buf, new_start, G_CONSOLE_BUFFER_SIZE - len);
        console->output.len -= len;
    }

    strcat(console->output.buf, fmt_input_buf);
    console->output.len += len;
}

g_gui_layer* g_console_create() {
    g_console* console = g_mem_calloc_named("Console", sizeof(g_console));
    memset(&console->input, 0, G_CONSOLE_BUFFER_SIZE);
    memset(&console->output, 0, G_CONSOLE_BUFFER_SIZE);

    log_add_callback(log_callback, console, LOG_INFO);

    g_gui_layer* layer = g_mem_calloc_named("Console GUI Layer", sizeof(g_gui_layer));
    layer->name = "Console";
    layer->draw = g_console_draw;
    layer->data = console;
    layer->open = 1;

    return layer;
}
