#include <gear/memory.h>
#include <gear/resources.h>
#include <gear/ui/console.h>
#include <gear/ui/gui.h>
#include <gear/ui/metrics.h>
#include <log.c/log.h>
#include <sokol/sokol_log.h>

struct nk_font* g_gui_font;

g_gui* g_gui_create() {
    simgui_setup(&(simgui_desc_t){
        .logger.func = slog_func,
        .ini_filename = "ui.ini",
    });
    log_info("Sokol nuklear initialized successfully");

    g_gui* gui = g_mem_calloc_named("GUI", sizeof(g_gui));
    g_gui_add_layer(&gui->layers, g_console_create, g_console_destroy);
    g_gui_add_layer(&gui->layers, g_metrics_create, g_metrics_destroy);

    return gui;
}
